/* acpropsearch.js
 *
 * ACCESS̃tH[ƃvpeB̒lB
 *
 * Copyright (c) 2008 OHTSUKA, Yoshio
 * This program is free to use, modify, extend at will. The author(s)
 * provides no warrantees, guarantees or any responsibility for usage.
 * Redistributions in any form must retain this copyright notice.
 * ohtsuka.yoshio@gmail.com
 */

var fso = new ActiveXObject("Scripting.FileSystemObject");
var args = WScript.Arguments;
var defInfo = {
   nocase:false,
   regexp:false,
   searchString:"",
   targetIsForm:true,
   targetIsReport:true,
   file:"",
   debug:false,
   reObj:null
}

//p[^̍쐬
var appInfo = {};
for (i in defInfo) { appInfo[i] = defInfo[i]; }

if (args.length < 2 || 3 < args.length) {
    errorParams();
}
if (args.length == 2) {
    appInfo.searchString = args(0);
    appInfo.file = args(1);
} else {
    appInfo.searchString = args(1);
    appInfo.file = args(2);

    var opts = args(0).split("");
    for (opt in opts) {
        var v = opts[opt];
        switch (v) {
            case "i":
                appInfo.nocase = true;
                break;
            case "R":
                appInfo.regexp = true;
                break;
            default:
                if ( !(opt == 0 && v == '-') ) {
                    errorParams(v);
                }
        }
    }
}
if (appInfo.regexp) {
    appInfo.reObj = new RegExp(appInfo.searchString, appInfo.nocase ? "i":"");
}

//Util֐
function puts (str) {WScript.echo(str);}
function exit () {WScript.Quit();}
function debugPrint(str) {
    if (appInfo.debug)
        WScript.echo("##ERROR## " + str);
}
function errorParams(badParamName) {
    if (badParamName != null) {
        puts ("sȃp[^[ł: " + badParamName);
    }
    puts("\:");
    puts("    " + WScript.ScriptName + " [options] pattern file");
    puts ("gp:");
    puts ("    " + WScript.ScriptName + " -Ri 'TEMP' work.mdb");
    puts("IvV:");
    puts("    -i 啶ʂȂ");
    puts("    -R K\");
    exit();
}

//}b`
function isMatch (str) {
    if (str == null || str == undefined || typeof(str) == "unknown") {
        return false;
    }
    if (appInfo.regexp) {
        var result = str.toString().search(appInfo.reObj);
        if (result != -1) {
            return true;
        }
    } else {
        var stext = str.toString();
        var qtext = appInfo.searchString;
        if (appInfo.nocase) {
            stext = stext.toUpperCase();
            qtext = qtext.toUpperCase();
        }
        if (stext.indexOf(qtext, 0) != -1) {
            return true;
        }
    }
    return false;
}

//
function searchInControl (control) {
    var prefix = getFullName (control) + ".";
    var props = new Enumerator(control.Properties);
    for (; props.atEnd() != true; props.moveNext()) {
        var prop = props.item();
        try {
            var value = prop.Value
        } catch (e) {
//            debugPrint(prefix + prop.Name + "=" + e.description);
            continue;
        }
        if (isMatch(value) == true) {
            puts(prefix + prop.Name + ": " + value);
        }
    }
}

//SC擾
function getFullName (obj) {
    var name = obj.Name;
    while (1) {
        try {
            name = obj.Parent.Name + "." + name;
            obj = obj.Parent;
        } catch (e) { break; }
    }
    return name;
}

//C
var app = new ActiveXObject("Access.Application");
app.Visible = appInfo.debug;
var file = fso.GetAbsolutePathName(appInfo.file);
puts (file);

try {
app.OpenCurrentDatabase(file);
} catch (e) {
    puts (e.description);
    exit();
}
var proj = app.CurrentProject;

//Form
var objs = new Enumerator(proj.AllForms);
for (; objs.atEnd() != true; objs.moveNext()) {
    var obj = objs.item();
    app.DoCmd.OpenForm(obj.Name, 1); //acDesign = 1;
    searchInControl (app.Forms(obj.Name));

    var controls = new Enumerator(app.Forms(obj.Name).Controls);
    for (; controls.atEnd() != true; controls.moveNext()) {
        searchInControl (controls.item());
    }
    app.DoCmd.Close(2, obj.Name);//acForm = 2, acSaveNo = ?
}
//Report
var objs = new Enumerator(proj.AllReports);
for (; objs.atEnd() != true; objs.moveNext()) {
    var obj = objs.item();
    app.DoCmd.OpenReport(obj.Name, 1); //acDesign = 1;
    searchInControl (app.Reports(obj.Name));

    var controls = new Enumerator(app.Reports(obj.Name).Controls);
    for (; controls.atEnd() != true; controls.moveNext()) {
        searchInControl (controls.item());
    }
    app.DoCmd.Close(3, obj.Name);//acReport = 2, acSaveNo = ?
}

app.CloseCurrentDatabase();
app.Quit();
exit();
